import React, { Suspense } from 'react';
import type { Metadata } from 'next';
import LoadingSpinner from '@/components/loading/LoadingSpinner';
import Header from '@/components/header/header';
import Footer from '@/components/footer/footer';
import '@/scss/main.scss';
import { AppRouterCacheProvider } from '@mui/material-nextjs/v13-appRouter';
import { ThemeProvider } from '@mui/material/styles';
import theme from '@/scss/theme/theme';
import { AuthContextProvider } from '@/context/AuthContex';
import { SocketContextProvider } from '@/context/SocketContex';

export const metadata: Metadata = {
  title: 'Create CarLinkX App',
  description: 'Generated by create app'
};

export default function RootLayout({
  children
}: Readonly<{
  children: React.ReactNode;
}>) {
  return (
    <html lang="en">
      <body>
        <AuthContextProvider>
          <SocketContextProvider>
            <Header />

            <AppRouterCacheProvider>
              <ThemeProvider theme={theme}>
                <Suspense fallback={<LoadingSpinner />}>{children}</Suspense>
              </ThemeProvider>
            </AppRouterCacheProvider>
          </SocketContextProvider>
        </AuthContextProvider>

        <Footer />
      </body>
    </html>
  );
}
